TRCL_ATTENDANCE = TRCL_ATTENDANCE or LibStub("AceAddon-3.0"):NewAddon("TRCLOOT_ATTENDANCE", "AceConsole-3.0")
local st = st or LibStub("ScrollingTable")
local ta = TRCL_ATTENDANCE



ta.ADDON_NAME = "RavenLoot_Attendance"

local NUM_ROW_GUILD = 15
local HEIGHT_ROW_GUILD = 20

local COL_SELECTED = 1
local COL_GROUP = 2
local COL_NAME = 3
local COL_POINTS = 4
local COL_BACKUP = 5
local COL_STREAK = 6
local COL_FACTOR = 7
local COL_REALM = 8

ta.tableData = {}

ta.roster = {}
ta.selected = {}
ta.updatingNotes = false
ta.attendanceFactors = {}
ta.attendanceFactorsCached = false

ta.maxPoints = 9
ta.maxBackup = 6
ta.backupStreak = 6


-- Load SVC
local addonLoadedFrame = CreateFrame("Frame")
addonLoadedFrame:RegisterEvent("ADDON_LOADED")
addonLoadedFrame:SetScript("OnEvent", function(self, event, addon)

    if addon == ta.ADDON_NAME then
        if RavenLootAttendance_svc == nil then
            RavenLootAttendance_svc = {}
        end

        ta.svc = RavenLootAttendance_svc
    end
end)




-- Build class table
local classNames = {}
local numClasses = GetNumClasses()
for n=1, numClasses do 
    local locName, name = GetClassInfo(n)
    classNames[locName] = name
end



-- UI frame
local f = CreateFrame("frame", ta.ADDON_NAME.."UIFrame", UIParent)
f:SetWidth(480)
f:SetHeight(400)
f:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 200, -200)
table.insert(UISpecialFrames, ta.ADDON_NAME.."UIFrame")
ta.f = f


-- Draw bg
local bg = f:CreateTexture(nil, "LOW", nil, 1)
bg:SetTexture("Interface\\AddOns\\RavenLoot\\Media\\square")
bg:SetPoint("CENTER", f, "CENTER", 0, 0)
bg:SetWidth(f:GetWidth())
bg:SetHeight(f:GetHeight())
bg:SetVertexColor(0,0,0,.8)


-- Header, usedto store title and make window movable
local bgHeaderFrame = CreateFrame("Button", f)
bgHeaderFrame:SetPoint("TOPLEFT", bg, "TOPLEFT")
bgHeaderFrame:SetWidth((bg:GetWidth() - 30) * GetCVar("uiScale"))
bgHeaderFrame:SetHeight(30 * GetCVar("uiScale"))


-- Start dragging
bgHeaderFrame:SetScript("OnMouseDown", function(self, button)
    f:SetMovable(true)
    f:StartMoving()
end)

-- Stop dragging
bgHeaderFrame:SetScript("OnMouseUp", function(self, button)
    f:StopMovingOrSizing()
    f:SetMovable(false)
    if ta.svc then
        local newAnchorSelf, _,newAnchorOther, newAnchorOffsetX, newAnchorOffsetY = f:GetPoint(1)
        ta.svc.anchorSelf = newAnchorSelf
        ta.svc.anchorOther = newAnchorOther
        ta.svc.anchorOffsetX = newAnchorOffsetX
        ta.svc.anchorOffsetY = newAnchorOffsetY
    end
end)


-- Header text
local headText = f:CreateFontString(ta.ADDON_NAME.."AttendanceTitle", "ARTWORK", "GameFontNormalLarge")
headText:SetPoint("CENTER", bgHeaderFrame, "CENTER", 20, 0)
headText:SetText("Raven Loot Attendance")
headText:SetJustifyH("CENTER")
headText:Show()


-- Close button on top right
local closeButtonFrame = CreateFrame("Button", f)
closeButtonFrame:SetPoint("TOPRIGHT", bg, "TOPRIGHT")
closeButtonFrame:SetWidth(30 * GetCVar("uiScale"))
closeButtonFrame:SetHeight(30 * GetCVar("uiScale"))
closeButtonFrame:SetScript("OnClick", function() 
    f:Hide()
end)


local closeButtonText = f:CreateFontString(ta.ADDON_NAME.."AttendanceTitle", "ARTWORK", "GameFontHighlight")
closeButtonText:SetPoint("CENTER", closeButtonFrame, "CENTER", 0, 0)
closeButtonText:SetText("X")
closeButtonText:SetJustifyH("CENTER")
closeButtonText:Show()


-- Thanks CrossRealmAssist for this snippet.
local sortBase = function(col, value)
    local column = ta.t.cols[col];
    local direction = column.sort or column.defaultsort or "asc"
    if direction == "asc" then
        return value
    else
        return not value;
    end
end




local colSort = function (_, a, b, col)
    if a == nil or b == nil then return false end; 
    local valA = ta.t:GetRow(a).cols[col].value
    if type(valA) == "string" then
        local valAStripped = valA:match("|c%x%x%x%x%x%x%x%x(%S+)|r")
        valA = valAStripped or valA
    end

    local valB = ta.t:GetRow(b).cols[col].value
    if type(valB) == "string" then
        local valBStripped = valB:match("|c%x%x%x%x%x%x%x%x(%S+)|r")
        valB = valBStripped or valB
    end

    if (valA == valB) and (col ~= COL_NAME) then
        valA = ta.t:GetRow(a).cols[COL_NAME].value
        if type(valA) == "string" then
            local valAStripped = valA:match("|c%x%x%x%x%x%x%x%x(%S+)|r")
            valA = valAStripped or valA
        end

        valB = ta.t:GetRow(b).cols[COL_NAME].value
        if type(valB) == "string" then
            local valBStripped = valB:match("|c%x%x%x%x%x%x%x%x(%S+)|r")
            valB = valBStripped or valB
        end

    end
    return sortBase(col, valA < valB)
end



-- Setup columns for table
local colSelected = 
{
   ["name"] = " ",
   ["width"] = 30,
   ["align"] = "CENTER",
   ["color"] = {["r"] = 1, ["g"] = 1, ["b"] = 1.0, ["a"] = 1.0 }, 
   ["colorargs"] = nil,
   ["bgcolor"] = { ["r"] = 1.0, ["g"] = 0.0, ["b"] = 0.0, ["a"] = 0.0 }, -- red backgrounds, eww
   ["defaultsort"] = "dsc",
   ["sortnext"]= COL_NAME,
   ["comparesort"] = colSort,
   ["DoCellUpdate"] = nil,
}
local colGroup = 
{
   ["name"] = "Group",
   ["width"] = 40,
   ["align"] = "CENTER",
   ["color"] = {["r"] = 1, ["g"] = 1, ["b"] = 1.0, ["a"] = 1.0 }, 
   ["colorargs"] = nil,
   ["bgcolor"] = { ["r"] = 1.0, ["g"] = 0.0, ["b"] = 0.0, ["a"] = 0.0 }, -- red backgrounds, eww!
   ["defaultsort"] = "dsc",
   ["sortnext"]= COL_NAME,
   ["comparesort"] = colSort,
   ["DoCellUpdate"] = nil,
}
local colName = 
{
   ["name"] = "Name",
   ["width"] = 150,
   ["align"] = "LEFT",
   ["color"] = {["r"] = 1, ["g"] = 1, ["b"] = 1.0, ["a"] = 1.0 }, 
   ["colorargs"] = nil,
   ["bgcolor"] = { ["r"] = 1.0, ["g"] = 0.0, ["b"] = 0.0, ["a"] = 0.0 }, -- red backgrounds, eww!
   ["defaultsort"] = "dsc",
   ["sortnext"]= COL_POINTS,
   ["comparesort"] = colSort,
   ["DoCellUpdate"] = nil,
}
local colPoints =
{
   ["name"] = "Points",
   ["width"] = 50,
   ["align"] = "CENTER",
   ["color"] = { ["r"] = 1, ["g"] = 1, ["b"] = 1.0, ["a"] = 1.0 },
   ["colorargs"] = nil,
   ["bgcolor"] = { ["r"] = 1.0, ["g"] = 0.0, ["b"] = 0.0, ["a"] = 0.0 }, -- red backgrounds, eww!
   ["defaultsort"] = "dsc",
   ["sortnext"]= COL_BACKUP,
   ["comparesort"] = colSort,
   ["DoCellUpdate"] = nil,
}
local colBackupPoints =
{
   ["name"] = "Backup",
   ["width"] = 50,
   ["align"] = "CENTER",
   ["color"] = { ["r"] = 1, ["g"] = 1, ["b"] = 1.0, ["a"] = 1.0 },
   ["colorargs"] = nil,
   ["bgcolor"] = { ["r"] = 1.0, ["g"] = 0.0, ["b"] = 0.0, ["a"] = 0.0 }, -- red backgrounds, eww!
   ["defaultsort"] = "dsc",
   ["sortnext"]= COL_STREAK,
   ["comparesort"] = colSort,
   ["DoCellUpdate"] = nil,
}
local colConsecutive =
{
   ["name"] = "Streak",
   ["width"] = 50,
   ["align"] = "CENTER",
   ["color"] = { ["r"] = 1, ["g"] = 1, ["b"] = 1.0, ["a"] = 1.0 },
   ["colorargs"] = nil,
   ["bgcolor"] = { ["r"] = 1.0, ["g"] = 0.0, ["b"] = 0.0, ["a"] = 0.0 }, -- red backgrounds, eww!
   ["defaultsort"] = "dsc",
   ["sortnext"]= nil,
   ["comparesort"] = colSort,
   ["DoCellUpdate"] = nil,
}

local colFactor =
{
   ["name"] = "Factor",
   ["width"] = 50,
   ["align"] = "CENTER",
   ["color"] = { ["r"] = 1, ["g"] = 1, ["b"] = 1.0, ["a"] = 1.0 },
   ["colorargs"] = nil,
   ["bgcolor"] = { ["r"] = 1.0, ["g"] = 0.0, ["b"] = 0.0, ["a"] = 0.0 }, -- red backgrounds, eww!
   ["defaultsort"] = "dsc",
   ["sortnext"]= nil,
   ["comparesort"] = colSort,
   ["DoCellUpdate"] = nil,
}
local colRealmName =
{
   ["name"] = "Realm",
   ["width"] = 0,
   ["align"] = "CENTER",
   ["color"] = { ["r"] = 1, ["g"] = 1, ["b"] = 1.0, ["a"] = 1.0 },
   ["colorargs"] = nil,
   ["bgcolor"] = { ["r"] = 1.0, ["g"] = 0.0, ["b"] = 0.0, ["a"] = 0.0 }, -- red backgrounds, eww!
   ["defaultsort"] = "dsc",
   ["sortnext"]= COL_NAME,
   ["comparesort"] = colSort,
   ["DoCellUpdate"] = nil,
}

cols = {
    [COL_SELECTED] = colSelected,
    [COL_GROUP] = colGroup,
    [COL_NAME] = colName,
    [COL_POINTS] = colPoints,
    [COL_BACKUP] = colBackupPoints,
    [COL_STREAK] = colConsecutive,
    [COL_FACTOR] = colFactor,
    [COL_REALM] = colRealmName}


-- Create table
ta.t = ta.t or st:CreateST(cols, NUM_ROW_GUILD, HEIGHT_ROW_GUILD, nil, UIParent)
ta.t.frame:SetPoint("CENTER", f, "CENTER", 0, -10)


-- Filter to group1 by default
ta.t:SetFilter(function(self, row) 
    return row.cols[COL_GROUP].value == "1"
end)
local selectedGroup = 1


--[[ DROPDOWN ]]--

-- Dropdown text
local groupText = f:CreateFontString(ta.ADDON_NAME.."GroupDropdownTitle", "ARTWORK", "GameFontNormal")
groupText:SetPoint("TOPLEFT", ta.t.frame, "BOTTOMLEFT", 2, -6)
groupText:SetText("Group: ")
groupText:SetJustifyH("LEFT")
groupText:Show()


-- Group dropdown
local dropdown = CreateFrame("Button", ta.ADDON_NAME.."GroupDropdown", f, "UIDropDownMenuTemplate")
dropdown:ClearAllPoints()
dropdown:SetPoint("LEFT", groupText, "RIGHT", -15, -5)
dropdown:Show()



local width = 64
UIDropDownMenu_Initialize(dropdown, function(self, level)
    local info = UIDropDownMenu_CreateInfo()
    for n=1, 2 do
        info = UIDropDownMenu_CreateInfo()
        info.text = n
        info.value = n
        info.func = function(self)
            UIDropDownMenu_SetSelectedID(dropdown, self:GetID())
            ta.t:SetFilter(function(self, row) 
                return row.cols[COL_GROUP].value == n..""
            end)
            selectedGroup = n
        end
        UIDropDownMenu_AddButton(info, level)
    end
end)
UIDropDownMenu_SetWidth(dropdown, width-24);
UIDropDownMenu_SetButtonWidth(dropdown, width)
UIDropDownMenu_SetSelectedID(dropdown, 1)
UIDropDownMenu_JustifyText(dropdown, "CENTER")

-- Apply attendance confirm dialogue
StaticPopupDialogs["RL_ATTENDANCE_CONFIRM_APPLY"] = {
   text = "Are you sure you want to apply attendance? This action cannot be reverted.",
   button1 = "Yes",
   button2 = "No",
   OnAccept = function()
       updatingNotes = true

       local updateQueue = {}

       for name, data in pairs(ta.roster) do
           local group = data.group
           local attendance = data.attendance
           local backupPoints = data.backupPoints
           local streak = data.streak


           if data and tonumber(data.group) == tonumber(selectedGroup) then
               -- Update attendance points
               for n=1, #(data.attendance)-1 do
                   data.attendance[n] = data.attendance[n+1]
               end

               if ta.selected[name] then
                   -- Was present this raid
                   data.attendance[ta.maxPoints] = true
                   data.streak = data.streak + 1
                   if data.streak == ta.backupStreak then
                       if data.backupPoints < ta.maxBackup then
                           data.backupPoints = data.backupPoints + 1
                       end
                       data.streak = 0
                   end

                   -- Use backup points
                   n=ta.maxPoints - 1
                   while not data.attendance[n] and n>0 and data.backupPoints >0 do
                       data.attendance[n] = true
                       data.backupPoints = data.backupPoints - 1
                       n = n - 1
                   end

               else
                   -- Was not present this raid
                   data.attendance[ta.maxPoints] = false
                   data.streak = 0

               end


               if data.mainName then
                   -- If this is an altj
                   if updateQueue[data.mainNameFull] then
                       -- If the main is already in the queue
                       if (not updateQueue[data.mainNameFull].attendance[ta.maxPoints]) and data.attendance[ta.maxPoints] then
                           -- If the main not selected, but the alt is, overwrite the main's data with alt's 
                           data.index = ta.roster[data.mainNameFull].index
                           updateQueue[data.mainNameFull] = data
                       end
                   else
                       -- If the main is not yet in the queue, add the alt
                       data.index = ta.roster[data.mainNameFull].index
                       updateQueue[data.mainNameFull] = data
                   end
               else
                   -- If this is a main
                   if updateQueue[name] then
                       -- If the entry was already set by an alt
                       if (not updateQueue[name].attendance[ta.maxPoints]) then
                           -- If alt was not selected, set to main's entry
                           updateQueue[name] = data
                       end
                   else
                       -- If entry was not yet set
                       updateQueue[name] = data
                   end

               end



           end


       end

       -- Set the officer notes
       for name, data in pairs(updateQueue) do
           local newNote = ta.packNote(data.group, data.attendance, data.backupPoints, data.streak)

           -- TODO: Check if index is still correct
           GuildRosterSetOfficerNote(data.index, newNote)
       end


       updatingNotes = false
       GuildRoster()

   end,
   timeout = 0,
   whileDead = true,
   hideOnEscape = true,
   preferredIndex = 3,  -- avoid some UI taint, see http://www.wowace.com/announcements/how-to-avoid-some-ui-taint/
}


-- Check raid and apply attendance buttons are only available if you can edit the notes
if CanEditOfficerNote() then
    -- Check raid button
    local selectRaidButton = CreateFrame("Button", ta.ADDON_NAME.."CheckRaidButton", f) 
    selectRaidButton:SetPoint("LEFT", dropdown, "RIGHT", 0, -4)
    selectRaidButton:SetWidth(160)
    selectRaidButton:SetHeight(36)

    selectRaidButton:SetNormalFontObject("GameFontNormalSmall")

    selectRaidButton:SetNormalTexture("Interface/Buttons/UI-Panel-Button-Up")
    selectRaidButton:SetHighlightTexture("Interface/Buttons/UI-Panel-Button-Highlight")
    selectRaidButton:SetPushedTexture("Interface/Buttons/UI-Panel-Button-Down")

    selectRaidButton:SetDisabledFontObject(GameFontDisable)
    selectRaidButton:SetHighlightFontObject(GameFontHighlight)
    selectRaidButton:SetNormalFontObject(GameFontNormal)

    local selectRaidFontObject = selectRaidButton:CreateFontString()
    --fo:SetFont("Fonts/FRIZQT__.TTF",12)
    selectRaidFontObject:SetFontObject("GameFontNormalSmall")
    selectRaidFontObject:SetPoint("TOPLEFT", selectRaidButton, "TOPLEFT", 16,-7)
    selectRaidFontObject:SetText("Select Raid")
    selectRaidButton:SetFontString(selectRaidFontObject)

    selectRaidButton:SetScript("OnClick", function() 
        local names = {}
        for n=1, GetNumGroupMembers() do

            local name = GetRaidRosterInfo(n)
            if not name:match("[^-][-][^-]") then
                local realmName = GetRealmName():gsub("%s+", "")
                name = name.."-"..realmName
            end

            ta.selected[name] = true

            ta.processRosterUpdate()

        end
    end)

    selectRaidButton:SetFrameStrata("MEDIUM")

    -- Apply Attendance button
    local applyButton = CreateFrame("Button", ta.ADDON_NAME.."UpdateButton", f) 
    applyButton:SetPoint("LEFT", selectRaidButton, "RIGHT", -52, 0)
    applyButton:SetWidth(220)
    applyButton:SetHeight(36)

    applyButton:SetNormalFontObject("GameFontNormalSmall")

    applyButton:SetNormalTexture("Interface/Buttons/UI-Panel-Button-Up")
    applyButton:SetHighlightTexture("Interface/Buttons/UI-Panel-Button-Highlight")
    applyButton:SetPushedTexture("Interface/Buttons/UI-Panel-Button-Down")

    applyButton:SetDisabledFontObject(GameFontDisable)
    applyButton:SetHighlightFontObject(GameFontHighlight)
    applyButton:SetNormalFontObject(GameFontNormal)

    local applyButtonFontObject = applyButton:CreateFontString()
    --fo:SetFont("Fonts/FRIZQT__.TTF",12)
    applyButtonFontObject:SetFontObject("GameFontNormalSmall")
    applyButtonFontObject:SetPoint("TOPLEFT", applyButton, "TOPLEFT", 16,-7)
    applyButtonFontObject:SetText("Apply attendance")
    applyButton:SetFontString(applyButtonFontObject)

    applyButton:SetScript("OnClick", function() 
        StaticPopup_Show("RL_ATTENDANCE_CONFIRM_APPLY")
    end)


    applyButton:SetFrameStrata("HIGH")

end


-- Register slash command and parse it
ta:RegisterChatCommand("rla", function(msg, editbox)
    f:Show()
end)

ta.getAttendanceFactors = function()

    -- If not cache it, generate table
    if not ta.attendanceFactorsCached then
        -- Clear existing table
        for k in pairs(ta.attendanceFactors) do
            ta.attendanceFactors[k] = nil
        end

        for name, data in pairs(ta.roster) do
            if data.points then 
                ta.attendanceFactors[name] = 0.5 + 0.5 * data.points / ta.maxPoints
            end
        end

        ta.attendanceFactorsCached = true
    end

    return ta.attendanceFactors
end

-- Register the function so that Raven Loot knows where to get the attendance factors from.
if TRCLOOT and TRCLOOT.registerScoreFactorFunction then
    TRCLOOT.registerScoreFactorFunction(ta.getAttendanceFactors)
else
    print("Raven Loot Attendance requires a newer version of Raven Loot, please update.")
end


ta.extractName = function(name) 
    local charName = name:match("|c%x%x%x%x%x%x%x%x(%S+)|r")
    charName = charName or name
    return charName
end

ta.unpackNote = function(note)
     local l = {}
   
   for k,v in note:gmatch("([0-9]+):") do
      table.insert(l, k)
   end
   
   local attendance = l[2]
   local attendanceList =  {}
   for k,v in attendance:gmatch("([01])") do
      
      local present
      if k == '0' then
         present = false
      else
         present = true
      end
      
      
      table.insert(attendanceList, present)
   end
   
   l[2] = attendanceList
   l[3] = tonumber(l[3])
   l[4] = tonumber(l[4])
   
   return unpack(l)
end

ta.packNote = function(group, attendance, backupPoints, streak)
   local s =  ""
   
   s = s .. tostring(group)
   s = s .. ":"
   
   for k, v in pairs(attendance) do
      if v then
         s = s .. "1"
      else
         s = s .. "0"
      end
   end
   s = s .. ":"
   
   s = s .. tostring(backupPoints)
   s = s .. ":"
   
   s = s .. tostring(streak)
   s = s .. ":"
   
   
   return s
end

ta.countPoints = function(attendance)
    local points = 0
    for k,v in pairs(attendance) do
        if v then
            points = points + 1
        end
    end
    return points
end



ta.processRosterUpdate = function(self, event, ...)


    -- If currently updating the officer notes, dont proceed
    if updatingNotes then
        return
    end

    ta.attendanceFactorsCached = false

    local numMembers = GetNumGuildMembers()

    -- Cache the roster
    ta.tableData = {}
    for n=1, numMembers do
        fullName, _, _, _, class, _, note, officerNote = GetGuildRosterInfo(n)
        ta.roster[fullName] = {index=n, officerNote=officerNote, class=class}
    end

   
    -- Loop over the cached roster
    for fullName, data in pairs(ta.roster) do
        local row = {}

        local shortName = Ambiguate(fullName, "short")
        local realmName = fullName:match("[^-]+[-]([^-]+)")

        local group, attendance, backupPoints, streak

        
        if data.officerNote:match("[0-9]+:[01]*:[0-9]:[0-9]:") then
            -- if this is the main of a raider
            data.eOfficerNote = data.officerNote
            group, attendance, backupPoints, streak = ta.unpackNote(data.eOfficerNote)
        else
            if ta.roster[data.officerNote] then
                -- If this is an alt of a raider
                data.eOfficerNote = ta.roster[data.officerNote].officerNote
                data.mainNameFull = data.officerNote
                data.mainName = Ambiguate(data.officerNote, "short")
                group, attendance, backupPoints, streak = ta.unpackNote(data.eOfficerNote)
            else 
                -- If this is not a character of a raider
                data = nil
            end
        end

        -- Add the character to the table
        if data then
            local points = ta.countPoints(attendance)

            data.group = group
            data.attendance = attendance
            data.backupPoints = backupPoints
            data.streak = streak
            data.points = points

            local className = classNames[data.class]
            local classColor = RAID_CLASS_COLORS[className].colorStr
            
            local mainString = ""
            if data.mainName then
                mainString = " ("..data.mainName..")"
            end

            local nameString = "|c"..classColor..shortName.."|r"..mainString
            local selectedString = ""
            if ta.selected[fullName] then
                selectedString = "X"
            end

            local factor = 0.5 + 0.5 * points / ta.maxPoints
            local factorString = string.format("%.1f%%", factor*100)

            row["cols"] = {
                [COL_SELECTED] = {["value"] = selectedString, ["color"] = {r=1,g=0,b=0}},
                [COL_GROUP] = {["value"] = group, ["color"] = {r=1,g=1,b=1}},
                [COL_NAME] = {["value"] = nameString, ["color"] = {r=1,g=1,b=1}},
                [COL_POINTS] = {["value"] = points, ["color"] = {r=1-points/ta.maxPoints,g=(points/ta.maxPoints),b=.2}},
                [COL_BACKUP] = {["value"] = backupPoints, ["color"] = {r=1-backupPoints/ta.maxBackup,g=(backupPoints/ta.maxBackup),b=.2}},
                [COL_STREAK] = {["value"] = streak, ["color"] = {r=1,g=1,b=1}},
                [COL_FACTOR] = {["value"] = factorString, ["color"] = {r=1-(factor-0.5)*2,g=(factor-0.5)*2,b=.2}},
                [COL_REALM] = {["value"] = realmName, ["color"] = {r=1,g=1,b=1}},
            }


            table.insert(ta.tableData, row)


        end
    end

    ta.t:SetData(ta.tableData, false)

end



local rosterUpdateFrame = CreateFrame("Frame")
rosterUpdateFrame:RegisterEvent("GUILD_ROSTER_UPDATE")
rosterUpdateFrame:SetScript("OnEvent", ta.processRosterUpdate)
GuildRoster()



ta.t:RegisterEvents({
    ["OnClick"] = function (rowFrame, cellFrame, data, cols, row, realrow, column, scrollingTable)
        -- If header is clicked
        if row == nil then
            return
        end


        local shortName = ta.extractName(data[realrow].cols[COL_NAME].value)
        local realmName = data[realrow].cols[COL_REALM].value
        local name = shortName.."-"..realmName
        if ta.selected[name] == true then
            ta.selected[name] = false
            data[realrow].cols[COL_SELECTED].value = ""
        else
            ta.selected[name] = true
            data[realrow].cols[COL_SELECTED].value = "X"
        end


        ta.t:SetData(data, false)

    end

});

ta.hideFrame = function() 
    ta.t:Hide()
end

ta.showFrame = function()
    if ta.svc and ta.svc.anchorOffsetX then
        local anchorOffsetX = ta.svc.anchorOffsetX or 0
        local anchorOffsetY = ta.svc.anchorOffsetY or 0
        local anchorSelf = ta.svc.anchorSelf or "CENTER"
        local anchorOther = ta.svc.anchorOther or "CENTER"
        
        f:ClearAllPoints()
        f:SetPoint(anchorSelf, UIParent, anchorOther, anchorOffsetX, anchorOffsetY)
    end
    ta.t:Show()

end

f:SetScript("OnHide", function()
    ta.hideFrame()
end)
f:SetScript("OnShow", function()
    ta.showFrame()
end)

ta.hideFrame()

